function Pb=BS_1D(xb,sigma,D,alfa,r)
E = 1; S = 4; 
N = 41; ep = 1; x = linspace(0,S,N)';
[A,Aex,Aexx] = deal(zeros(N,N));
for i=1:N
    dx = x(:)-x(i); r2 = dx.^2;
    A(:,i) = 1./sqrt(1+ep^2*r2);
    Aex(:,i) = -ep^2*dx.*(1./sqrt(1+ep^2*r2)).^3;
    Aexx(:,i) = (3*r2*ep^4)./(r2*ep^2+1).^(5/2)-ep^2./(r2*ep^2+1).^(3/2);
end
Ax = Aex/(A); Axx = Aexx/(A);
D1xd = Ax(2:end-1,2:end-1); D1xxd = Axx(2:end-1,2:end-1);
D1xb = Ax(2:end-1,[1 N]);   D1xxb = Axx(2:end-1,[1 N]); 
 
F = [E/alfa;0];
Wb = (.5*sigma^2*diag(x(2:end-1))^2*D1xxb-(D-r)*diag(x(2:end-1))*D1xb)*F;
Wd = (.5*sigma^2*diag(x(2:end-1))^2*D1xxd-(D-r)*diag(x(2:end-1))*D1xd-r*eye(N-2,N-2));
P0 = max(0,E-alfa*x(2:end-1)); 
Tf = 1; t = 0:0.05:Tf; opt = odeset('RelTol',1e-10);
%ode solver for finding the solution of the 1D Amrican option
[T,P] = ode15s(@(t,P)odefun_1D(P,x,Wd,Wb,alfa,r,E),t,P0,opt);
%P(length(T),:)
Ab=zeros(length(xb),N-2);
for i=1:length(xb)
    r2b = (xb(i)-x(2:end-1)).^2; Ab(i,:) = 1./sqrt(1+ep^2*r2b);
end
Pb=(Ab/A(2:end-1,2:end-1))*P(length(T),:)';
end
function dPdt=odefun_1D(P,x,Wd,Wb,alfa,r,E)
eps=0.00001; C=r; 
q=zeros(length(P),1);
q(:)=+eps*C./(P(:)+eps-(E-alfa*x(2:end-1)));
dPdt=Wd*P+q+Wb;
end
