function [Ax,Axx,Ay,Ayy,Axy] = PUM_BS_diffmat(data,center,R,h)
N = length(data); M = length(center);
% For each patch, find which node points that lie inside.
Omega = cell(M,1); indice = cell(M,1); ep=zeros(M,1);
for j=1:M
    indice{j} = find(hypot((data(:,1)-center(j,1))/R(j,1),(data(:,2)-center(j,2))/R(j,2))<1);
     Omega{j} = [data(indice{j},1) data(indice{j},2)];
     ep(j)=h/min(pdist(data(indice{j},:)));
%       dif=[diff(data(indice{j},1));diff(data(indice{j},2))]; indi=find(dif);
%       ep(j)=h/min(abs(dif(indi)));
end
% Generate differentiation matrices
[Ax,Ay,Axx,Ayy,Axy]=deal(sparse(N,N));
for i=1:N
% Find the active centers for each node 
 Ix=find( hypot((data(i,1)-center(:,1))./R(:,1) , (data(i,2)-center(:,2))./R(:,2))<1);
 activecen = center(Ix,:); epa=ep(Ix); Ra=R(Ix,:);
%--------------------------------------------------------------------------
%generate pum weight 
[w,wx,wy,wxx,wyy,wxy] = weight_PUM(data(i,:),activecen,Ra);
   for k=1:length(Ix); %Number of the active centers for each node
      [psi,psix,psiy,psixx,psiyy,psixy] = imq_PUM(epa(k),Omega{Ix(k)},data(i,:));
      Ax(i,indice{Ix(k)}) = Ax(i,indice{Ix(k)}) + (wx(k)*psi + w(k)*psix);
      Ay(i,indice{Ix(k)}) = Ay(i,indice{Ix(k)}) + (wy(k)*psi + w(k)*psiy);
      Axx(i,indice{Ix(k)}) = Axx(i,indice{Ix(k)}) + (wxx(k)*psi + 2*wx(k)*psix + w(k)*psixx);
      Ayy(i,indice{Ix(k)}) = Ayy(i,indice{Ix(k)}) + (wyy(k)*psi + 2*wy(k)*psiy + w(k)*psiyy);  
      Axy(i,indice{Ix(k)}) = Axy(i,indice{Ix(k)})+(w(k)*psixy+...
                             wy(k)*psix+wx(k)*psiy+ wxy(k)*psi);
   end
end